 package org.sky.system.service.impl;

 import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
 import com.baomidou.mybatisplus.core.metadata.IPage;
 import com.baomidou.mybatisplus.core.toolkit.Wrappers;
 import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
 import org.sky.common.constant.CommonConstant;
 import org.sky.core.cache.utils.CacheUtil;
 import org.sky.core.log.exception.ServiceException;
 import org.sky.core.mp.support.Condition;
 import org.sky.core.mp.support.Query;
 import org.sky.core.secure.utils.AuthUtil;
 import org.sky.core.tool.constant.KdConstant;
 import org.sky.core.tool.node.ForestNodeMerger;
 import org.sky.core.tool.utils.Func;
 import org.sky.core.tool.utils.StringPool;
 import org.sky.core.tool.utils.StringUtil;
 import org.sky.system.cache.DictBizCache;
 import org.sky.system.mapper.DictBizMapper;
 import org.sky.system.pojo.entity.DictBiz;
 import org.sky.system.pojo.vo.DictBizVO;
 import org.sky.system.service.IDictBizService;
 import org.sky.system.wrapper.DictBizWrapper;
 import org.springframework.stereotype.Service;

 import java.util.ArrayList;
 import java.util.List;
 import java.util.Map;

 import static org.sky.core.cache.constant.CacheConstant.DICT_CACHE;

/**
 * 服务实现类
 *
 */
@Service
public class DictBizServiceImpl extends ServiceImpl<DictBizMapper, DictBiz> implements IDictBizService {

	@Override
	public List<DictBizVO> tree() {
		return ForestNodeMerger.merge(baseMapper.tree());
	}

	@Override
	public List<DictBizVO> parentTree() {
		return ForestNodeMerger.merge(baseMapper.parentTree());
	}

	@Override
	public String getValue(String code, String dictKey) {
		List<DictBiz> dictList = baseMapper.selectList(
			Wrappers.<DictBiz>lambdaQuery().eq(DictBiz::getTenantId, AuthUtil.getTenantId()).eq(DictBiz::getCode, code).eq(DictBiz::getDictKey, dictKey)
		);
		return dictList.stream()
			.filter(dict -> StringUtil.equals(dict.getDictKey(), dictKey))
			.findFirst()
			.map(DictBiz::getDictValue)
			.orElse(StringPool.EMPTY);
	}

	@Override
	public List<DictBiz> getList(String code) {
		return baseMapper.getList(AuthUtil.getTenantId(), code);
	}

	@Override
	public String getValue(String tenantId, String code, String dictKey) {
		if (AuthUtil.isAdministrator()) {
			return Func.toStr(baseMapper.getValue(tenantId, code, dictKey), StringPool.EMPTY);
		}
		return this.getValue(code, dictKey);
	}

	@Override
	public List<DictBiz> getList(String tenantId, String code) {
		if (AuthUtil.isAdministrator()) {
			return baseMapper.getList(tenantId, code);
		}
		return this.getList(code);
	}

	@Override
	public boolean submit(DictBiz dict) {
		LambdaQueryWrapper<DictBiz> lqw = Wrappers.<DictBiz>query().lambda().eq(DictBiz::getCode, dict.getCode()).eq(DictBiz::getDictKey, dict.getDictKey());
		Long cnt = baseMapper.selectCount((Func.isEmpty(dict.getId())) ? lqw : lqw.notIn(DictBiz::getId, dict.getId()));
		if (cnt > 0L) {
			throw new ServiceException("当前字典键值已存在!");
		}
		// 修改顶级字典后同步更新下属字典的编号
		if (Func.isNotEmpty(dict.getId()) && dict.getParentId().longValue() == KdConstant.TOP_PARENT_ID) {
			DictBiz parent = DictBizCache.getById(dict.getId());
			this.update(Wrappers.<DictBiz>update().lambda().set(DictBiz::getCode, dict.getCode()).eq(DictBiz::getCode, parent.getCode()).ne(DictBiz::getParentId, KdConstant.TOP_PARENT_ID));
		}
		if (Func.isEmpty(dict.getParentId())) {
			dict.setParentId(KdConstant.TOP_PARENT_ID);
		}
		dict.setIsDeleted(KdConstant.DB_NOT_DELETED);
		CacheUtil.clear(DICT_CACHE);
		return saveOrUpdate(dict);
	}

	@Override
	public boolean removeDict(String ids) {
		Long cnt = baseMapper.selectCount(Wrappers.<DictBiz>query().lambda().in(DictBiz::getParentId, Func.toLongList(ids)));
		if (cnt > 0L) {
			throw new ServiceException("请先删除子节点!");
		}
		return removeByIds(Func.toLongList(ids));
	}

	@Override
	public IPage<DictBizVO> parentList(Map<String, Object> dict, Query query) {
		IPage<DictBiz> page = this.page(Condition.getPage(query), Condition.getQueryWrapper(dict, DictBiz.class).lambda().eq(DictBiz::getParentId, CommonConstant.TOP_PARENT_ID).orderByAsc(DictBiz::getSort));
		return DictBizWrapper.build().pageVO(page);
	}

	@Override
	public List<DictBizVO> childList(Map<String, Object> dict, Long parentId) {
		if (parentId < 0) {
			return new ArrayList<>();
		}
		dict.remove("parentId");
		DictBiz parentDict = DictBizCache.getById(parentId);
		List<DictBiz> list = this.list(Condition.getQueryWrapper(dict, DictBiz.class).lambda().ne(DictBiz::getId, parentId).eq(DictBiz::getCode, parentDict.getCode()).orderByAsc(DictBiz::getSort));
		return DictBizWrapper.build().listNodeVO(list);
	}

}
